#ifdef __QNX__

#define Uses_TEvent
#define Uses_TEventQueue
#define Uses_TKeys
#define Uses_TScreen
#include <tv.h>
#include <tvdir.h>

#include <term.h>
#include <ctype.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <iostream.h>
#include <sys/time.h>
#include <sys/qioctl.h>

/*
 * Expands a path into its directory and file components.
 */

void expandPath(const char *path, char *dir, char *file)
{
	char *tag = strrchr(path, '/');

	/* the path is in the form /dir1/dir2/file ? */

	if (tag != NULL)
	{
		strcpy(file, tag + 1);
		strncpy(dir, path, tag - path + 1);
		dir[tag - path + 1] = '\0';
	}
	else
	{
		/* there is only the file name */

		strcpy(file, path);
		dir[0] = '\0';
	}
}

void fexpand(char *path)
{
	char dir[MAXPATH];
	char file[MAXPATH];
	char oldPath[MAXPATH];

	expandPath(path, dir, file);
	getcwd(oldPath, sizeof(oldPath));
	chdir(dir);
	getcwd(dir, sizeof(dir));
	chdir(oldPath);
	if (strcmp(dir, "/") == 0) sprintf(path, "/%s", file);
	else sprintf(path, "%s/%s", dir, file);
}

unsigned char getShiftState()
{
  uchar TVState=0;
  char SendBuffer[0x08]={0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
  char RecvBuffer[0x04]={0x00, 0x00, 0x00, 0x00};

  qnx_ioctl(fileno(stdin), QCTL_DEV_CTL, SendBuffer, 0x08, RecvBuffer, 0x04);
  
  if (RecvBuffer[0x02]&0x01) TVState|=kbLeftShift;
  if (RecvBuffer[0x02]&0x02) TVState|=kbCtrlShift;
  if (RecvBuffer[0x02]&0x04) TVState|=kbAltShift;
  if (RecvBuffer[0x00]&0x01) TVState|=kbScrollState;
  if (RecvBuffer[0x00]&0x02) TVState|=kbNumState;
  if (RecvBuffer[0x00]&0x04) TVState|=kbCapsState;
  return TVState;
}

unsigned long getTicks()
{
   return clock()/(CLOCKS_PER_SEC*10/182);
}

#endif
